<template>
    <div>
        <div class="page-content">
            <page-header>
                <div class="container-fluid">
                    <div class="row">
                        <div class="col-9 col-xl-6 offset-xl-3">
                            <search-bar></search-bar>
                        </div>
                        <div class="col-3">
                            <div class="page-header-item-wrapper" style="height:70px; display:flex; align-items: center;">
                                <button class="button block" @click="createIssue($route.query.project)">
                                    Create issue
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </page-header>
            <div class="container-fluid">
                <div class="row">
                    <div class="col-12 col-xl-6 offset-xl-3">
                        <div class="page-title">
                            Issues
                        </div>
                        <div class="issue-list" v-if="issues.length > 0">
                            <div class="issue" v-for="issue in issues" :key="issue.id" @click="openIssue(issue)">
                                <div class="top">
                                    <div class="caption">{{issue.caption}}</div>
                                    <div class="assignees">
                                        <div class="assignee" v-for="assignee in issue.assignees" :key="assignee.id">
                                            <img :src="assignee.user.photoURL"/>
                                        </div>
                                    </div>
                                </div>
                                <div class="bottom">
                                    <div class="project" @click="$router.push({name: 'Project', params: {id: issue.project.id}})">
                                        <span>{{issue.project.displayName}}</span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="issue-list" v-else>
                            <div class="no-issues">
                                <img src="../../assets/problem_solving.svg"/>
                                No issues found, yay!
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import store from "../../store";
    import { mapState } from "vuex";
    import CreateIssue from "../../components/modals/CreateIssue";
    import ViewIssue from "../../components/modals/ViewIssue";

    export default {
      beforeRouteEnter(to, from, next) {

        let params;
        if (Object.keys(to.query).length === 0) {
          params = {assignee: 'me'};
        } else {
          params = to.query;
        }
        
        store.dispatch("issueModule/getIssues", params).then(() => {
          next();
        });
      },
      methods: {
        createIssue(project) {
          this.$modal.show(CreateIssue, {projectId: project});
        },
        openIssue(issue) {
          this.$modal.show(ViewIssue, {issue});
        }
      },
      computed: mapState("issueModule", ["issues"])
    };
</script>

<style lang="scss">
    .issue-list{
        width:100%;
        background-color:#EEEEEE;
        border:1px solid #C1C1C1;
        border-radius:8px;
        .no-issues{
            padding:15px;
            img{
                height:200px;
            }
            display:flex;
            flex-direction: column;
            justify-content: center;
            align-items: center;
        }
        .issue{
            display:flex;
            flex-direction: column;
            border-top:1px solid #C1C1C1;
            padding:10px;
            &:first-child{
                border-top:1px solid transparent;
            }
            .top{
                display:flex;
                .caption{
                    flex:1;
                    font-weight:600;
                    font-size:18px;
                }
                .assignees{
                    display:flex;
                    flex-direction: row-reverse;
                    .assignee{
                        width:25px;
                        height:25px;
                        border-radius:100%;
                        overflow: hidden;
                        margin-left:-10px;
                        border:3px solid #EEEEEE;
                        box-sizing: content-box;
                        img{
                            border-radius:100%;
                            width:100%;
                            height:100%;
                        }
                    }
                }
            }
            .bottom{
                .project{
                    font-weight:600;
                    font-size:16px;
                    color:#B8B8B8;
                    span:hover{
                        text-decoration: underline;
                        cursor:pointer;
                    }
                }
            }
        }
    }
</style>
